# Precursor (Precursor)

## Quick start guide
Precursor is designed to take the pain away from webpack configurations and isomorphic complexities, leaving you
with a super simple source folder with only the files you need. The chosen tech stack has been tried and tested
at RCA, and is extensible and highly configurable, whilst having a small footprint in your codebase.

### Starting a new project
Grab the latest seed project from the [RCA-Seed-app](https://git.realestate.com.au/craig-collie/rca-seed-app) repository. 

```bash
$ git clone git@git.realestate.com.au:craig-collie/rca-seed-app.git
```
Since `rca-precursor` is already a dependency in the seed project, you should only need to:

```bash
$ yarn
$ yarn start
```
And finally visit [http://localhost:3000](http://localhost:3000) in your browser.

### Migrating your project to Precursor
If you're feeling game enough to migrate, then simply add `rca-precursor` as a dependency, and follow the
migration documentation (that hasn't been written yet).

```bash
$ yarn add rca-precursor
```

## Technology Stack
| Tech | Description |
| --- | --- |
| [Node](https://nodejs.org/en) | JavaScript runtime build on Chrome's V8 JavaScript engine. |
| [Express](https://expressjs.com) | Fast, un-opinionated, minimalist web framework for Node.js |
| [Webpack](https://webpack.js.org) | Asset bundling |
| [Babel](https://babeljs.io) | Use next generation JavaScript today |
| [React](https://facebook.github.io/react) | A JavaScript library for building user interfaces |
| [CSS-Modules](https://github.com/css-modules/css-modules) | Locally scoped interoperable CSS |
| [PostCSS](http://postcss.org/) | CSS Pre-processing (using `SASS` syntax) and `autoprefixing` |
