import React, { Component } from 'react';

const LazyRoute = ({ load }) => (
  class HOC extends Component {
    state = { Module: null }
    async componentDidMount() {
      this.importBundle();
    }

    importBundle = async () => {
      const Module = await this.resolver();
      this.setState({ Module });
    }

    resolver = () => (
      new Promise((resolve) => {
        load(module => (resolve(module.default)));
      })
    )

    render() {
      const { Module } = this.state;
      if (!Module) {
        return null;
      }
      return <Module />;
    }
  }
);

export default LazyRoute;
