import React, { Component } from 'react';
import { Route } from 'react-router-dom';

import RoutePreloader from './RoutePreloader';

class UniversalRoute extends Component {
  constructor(props) {
    super(props);
    this.state = { mod: props.component };
  }
  componentDidMount() {
    this.resolveBundle();
  }

  resolveBundle = async () => {
    const { bundle } = this.props;
    if (bundle) {
      const resolved = await bundle.load();
      this.setState({ mod: resolved.default });
    }
  }

  render() {
    const { component, ...rest } = this.props;
    const { mod } = this.state;

    if (!mod) {
      return (<div>Loading</div>);
    }

    return (<Route {...rest} component={RoutePreloader(mod, rest)} />);
  }
}

export default UniversalRoute;
