//  @flow
import type { $Request, $Response } from 'express';
import type { IConfig } from '../../../flow/IConfig';
import type { IApp } from '../../../flow/IApp';

export default (app: IApp, config: IConfig) => (
  req: $Request,
  res: $Response,
  next: Function,
) => {
  const _app = app;
  const { environmentVariables } = config;
  if (_app.locals.isTokenized) {
    next();
  } else {
    if (environmentVariables) {
      Object.keys(environmentVariables).forEach((key) => {
        _app.locals.html = _app.locals.html.replace(`¡${key}!`, environmentVariables[key]);
      });
    }
    _app.locals.isTokenized = true;
    next();
  }
};
