import chalk from 'chalk';

const log = console.log;

const messages = {
  welcome: ({ appName, isDevEnvironment, port }) => (`                  
RCA-Precursor: Starting ${appName}
http://localhost:${port || 3000}
Environment: ${chalk.blue(isDevEnvironment ? 'Development' : 'Production')}
`),
};

export const getMessage = (type, args) => (
  messages[type] ? messages[type](args) : messages.error
);

export default err => (log(`
${chalk.blue('RCA-Juno:')} ${chalk.red(err)}
`));
